/* 
 *  Copyright (c) 2005 Saveliy Tretiakov (saveliyt@mail.ru)  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<windows.h>

void __RPC_FAR * __RPC_USER midl_user_allocate(size_t len)
{
	return(malloc(len));
}
 
void __RPC_USER midl_user_free(void __RPC_FAR * ptr)
{
	free(ptr);
}

handle_t __RPC_USER LPWSTR_bind(LPWSTR ServerName)
{
	handle_t bindingHandle;
	RPC_STATUS status;
	PWSTR sb;
	
	if(lstrcmpW(ServerName, L"\\\\.")==0)
	{
		status = RpcStringBindingComposeW(0, L"ncalrpc", 0, L"ntsvcs", 0, &sb);
		if(status == RPC_S_OK)
		{
			status = RpcBindingFromStringBindingW(sb, &bindingHandle);
			RpcStringFreeW(&sb);
			if(status == RPC_S_OK)
				return bindingHandle;
			else printf("Binding failed: %d\n", status);
		}
		return NULL;
	}
	else
	{
		printf("Remote binding is not implemented yet.");
		return NULL;
	}
}

void __RPC_USER LPWSTR_unbind(LPWSTR ServerName, handle_t hBinding)
{
	RpcBindingFree(hBinding);
}

handle_t __RPC_USER LPSTR_bind(LPSTR ServerName)
{
	handle_t result;
	WCHAR *wstr;
	UINT wsize;

	wsize = MultiByteToWideChar(CP_ACP, 0, ServerName, -1, NULL, 0);
	wstr = (WCHAR*)malloc(wsize);
	MultiByteToWideChar(CP_ACP, 0, ServerName, -1, wstr, wsize);
	result = LPWSTR_bind(wstr);
	free(wstr);
	return result;
}

void __RPC_USER LPSTR_unbind (LPSTR ServerName, handle_t hBinding)
{
	RpcBindingFree(hBinding);
}

