/* 
 *  Copyright (c) 2005 Saveliy Tretiakov (saveliyt@mail.ru)  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/* TEST DESCRIPTION
 *  Test EventLogGetInfo()
 *  Report event to Application and System logs.
 */

#include <stdio.h>
#include "eventlogrpc.h" 

#define LOGNAME "System"
#define COMPNAME "TEST_EVENTLOG"

int main()
{
	NTSTATUS result;
	UNICODE_STRING StrNull;
	HANDLE hLog;
	ULONG shit, bNeeded=0;
	ANSI_STRING LogName, CompName;
	EVENTLOG_FULL_INFORMATION Info;

	LogName.Length = strlen(LOGNAME);
	LogName.MaximumLength = strlen(LOGNAME);
	LogName.Buffer = LOGNAME;
	
	CompName.Length = strlen(COMPNAME);
	CompName.MaximumLength = strlen(COMPNAME);
	CompName.Buffer = COMPNAME;
	
	StrNull.Length = 0;
	StrNull.MaximumLength = 0;
	StrNull.Buffer = NULL;

	RpcTryExcept
	{
		printf("\n==================== ANSI FUNCTIONS TEST =====================\n");
		
		hLog = 0;
		result = EventLogOpenA("\\\\.",  &LogName, (PANSI_STRING)&StrNull, 1, 1, &hLog);
		printf("EventLogOpenA() returned %x, hLog = %x\n", result, hLog);
		
		Info.dwFull = 0;
		result = EventLogGetInfo(hLog, EVENTLOG_FULL_INFO, (PBYTE)&Info, sizeof(EVENTLOG_FULL_INFORMATION), &bNeeded);
		printf("EventLogGetInfo() returned %x, dwFull = %x, bNeeded = %d\n", result, Info.dwFull, bNeeded);
		
		result = EventLogReportEventA(hLog, 0, EVENTLOG_WARNING_TYPE, 3333, 31337, 0, 0, 
										&CompName, NULL, NULL, NULL, 0, &shit, &shit);
		printf("EventLogReportEventA() returned %x", result);
		
		EventLogClose(&hLog);
		
		printf("\n\n================== UNICODE FUNCTIONS TEST ====================\n");
		
		/* BUG BUG BUG BUG BUG BUG BUG BUG BUG BUG BUG BUG 
		   UNICODE_STRING initialized with nulls works, 
		   structure initialized with other values doesn't.  */		
		
		hLog = 0;
		result = EventLogOpenW(L"\\\\.", &StrNull, &StrNull, 1, 1, &hLog);
		printf("EventLogOpenW returned %x, hLog=%x\n", result, hLog);
		
		result = EventLogReportEventW(hLog, 0, EVENTLOG_WARNING_TYPE, 4444, 31337, 0, 0, 
										&StrNull, NULL, NULL, NULL, 0, &shit, &shit);
		printf("EventLogReportEventW() returned %x", result);
		EventLogClose(&hLog);	
	}
	RpcExcept(1) 
	{
		printf("Runtime reported exception %ld\n", RpcExceptionCode());
	}
	RpcEndExcept

	return 0;
}

