/* 
 *  Copyright (c) 2005 Saveliy Tretiakov (saveliyt@mail.ru)  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
/* TEST DESCRIPTION
 * Clear Application log.
 */

#include <stdio.h>
#include "eventlogrpc.h" 

int main()
{
	UNICODE_STRING StrNull;
	NTSTATUS result;
	HANDLE hLog;
	
	StrNull.Length = 0;
	StrNull.MaximumLength = 0;
	StrNull.Buffer = NULL;

	RpcTryExcept
	{
		
		hLog = 0;
		result = EventLogOpenW(L"\\\\.",  &StrNull, &StrNull, 1, 1, &hLog);
		printf("EventLogOpenW() returned %x, hLog = %x\n", result, hLog);
		
		result = EventLogClearW(hLog, &StrNull);
		printf("EventLogClearW() returned %x\n", result);
		
		EventLogClose(&hLog);
	}
	RpcExcept(1) 
	{
		printf("Runtime reported exception %ld\n", RpcExceptionCode());
	}
	RpcEndExcept

	return 0;
}

